Changes for Perl Application Development and Refactoring Environment

0.57 To Be Released


0.56 2010.02.01
    - Plugins may now add their GUI elements to the view menu (SEWI)
    - Padre now displays a dynamic to-do list generated from comments
      in your source code (CORION)
    - Landed new Padre::Startup module which is dramatically faster
      when loading files into an existing Padre via the single instance
      server, and finally provides a mechanism for allowing configuration
      to disable the startup splash image (ADAMK)
    - Changed a few configuration settings to create a more consistent
      naming pattern for them (ADAMK)
    - Audited dependencies and updated a variety of them (ADAMK)
    - Ctrl-Shift-W is now bound to "Close This Project" (ADAMK)
    - Added an option for traceing Padre subroutine calls to the
      developer plugin (SEWI)
    - Uses correct make from Config.pm for the run menu item -> Build and
      run tests (KTHAKORE)
    - Speedup and less false-shows for autocomplete (SEWI)
    - Speedup while changing tabs (use the correct project dir) (SEWI)
    - Simple refocus on document after command run (KTHAKORE)
    - Fixed ticket #822: main window could be off screen on start (BLAKEW)
    - padre-client allows you to use Padre for commit messages and other
      synchronous edit events (CORION)
    - WIN32, Converted the --desktop registry code to Win32::TieRegistry 
      and removed hardcoded strawberry paths (AZAWAWI)
    - WIN32, padre.exe will run with the same UAC privileges as same as
      the invoker (AZAWAWI)
    - Disable debugger menu items when there is no document (AZAWAWI)
    - Fixed a Padre debugger crash when an unsaved document is debugged (AZAWAWI)
    - Fixed Padre no-document crash with Find Next/Find Previous functionality
      (AZAWAWI)
    - Make sure that windows context key shows the refactor menu 
      items in the right-click pop-up menu (AZAWAWI)
    - Used Module::CoreList::is_deprecated to display deprecated CORE modules
      in help search title (AZAWAWI)
    - Padre::Util::Win32::ExecuteProcessAndWait doesn't automatically inherit
      the same Cwd as the parent process. Added support for explicit cwd
      parameter and make the syntax checker pass the cwd to it. Syntax checking
      of test scripts and such should now work as intended on Win32(ADAMK)
    - Audit uses of Padre::Util::Win32 to only load it via require. Added a
      TRACE warning to verify it never gets loaded on non-Win32 (ADAMK)
    - Tuned the locking for ->close_where, which should make a variety of
      functions like "Close This Project" and "Close Other Projects"
      noticably faster (ADAMK)
    - Changed func_foo config variables to feature_foo, in anticipation of
      of a future equivalent to the Mozilla "about:config" control (ADAMK)
    - Added feature_cursormemory to allow disabling of Padre's feature to
      remember the location in the file you were scrolled to (ADAMK)
    - Added a fast ascii shortcut to the very slow encode detector. Opening
      files all of a sudden gets much faster if you have ascii files (ADAMK)
    - Bumped ORLite to 1.38 to get faster ARRAY object support and
      Class::XSAccessor acceleration support. If they cause problems,
      these changes can be safely backed out. (ADAMK)
    - Fixed the mass-error-popups on mimetypes without help provider (SEWI)
    - During DB locks (which are the most likely place for things to make
      changes to the database) disable synchronous SQLite writes. This will
      reduce the time that Padre blocks, at the risk of config.db corruption
      if there is a hardware failure or operating system crash. (ADAMK)
    - Fixed ticket #837: padre.exe should be able to be placed in
      c:\strawberry\perl\site\bin (AZAWAWI)
    - Improved "Goto Line" dialog to be smarter with better validation/error
      messages (AZAWAWI)
    - Open Resource can now display Perl package names for matching resources
      (AZAWAWI)
    - Fixed #838: Author tests should all check RELEASE_TESTING and/or
      AUTOMATED_TESTING (RHEBUS, AZAWAWI)
    - Fixed Regex Editor dialog destruction bug where multiple ->Show and
      ->Destroy could lead to a Padre crash on WIN32 (AZAWAWI)
    - Project detection differentiates between four different subclasses
      of Perl build systems (three of those correctly) (ADAMK)
    - Function List has resource locking around it and properly triggers a
      refresh when we show it for an already open document (ADAMK)
    - "Goto Line" dialog now supports going to lines and positions (AZAWAWI)
    - Fixed perl to refactor action prefix for refactor menu for 
      consistency (AZAWAWI)
    - Fixed ticket #841: Quick Menu Access should show the location of the 
      menu item on the menu system (AZAWAWI)

0.55 2010.01.21
    - Add full list of file types to the View Document As menu (SZABGAB)
    - dist-zilla projects detection finally fixed (#489) (JQUELIN)
    - The directory tree refresh method will shortcut if nothing has
      changed, which should fix a number of bugs relating to the
      directory tree "doing things" when it shouldn't be (ADAMK)
    - Saving files to somewhere other than the current project will now
      correctly flush the document project state, and triggers a directory
      tree flush so that we communicate the change in project (ADAMK)
    - Cloned ORLite::Migrate to a private version as Padre::DB::Migrate
      so we have a better chance of fixing bug #796 (ADAMK)
    - Tentatively fixed #796 by spawning migration scripts in a manner which
      does NOT assume the pre-existance of STDOUT. This is at best a
      short-term hack, because this STDOUT problem is going to come back and
      bite us in other ways in the future, for sure (ADAMK)
    - Tuned the directory tree refresh logic to improve startup speed when
      launching Padre with specific named files to open (ADAMK)
    - Tuned the creation and management of tool widgets to remove the need
      to load or construct tools at startup time that are turned off in the
      user's configuration.
    - Tuned lock-release refresh execution to remove low-level refresh
      methods that are also contained in higher level refresh methods.
    - Removed a superfluous AUI Update from the refresh method (ADAMK)
    - Delay loading some additional GUI classes and objects until they
      definitely needed (ADAMK)
    - Suppress warnings that occur during plugin loading (ADAMK)
    - 'Simple' possible fix for #331 to update the tabs when 'save all' is 
      run in Padre. (PLAVEN)
    - Fixed #819: Don't crash on missing project dir (SEWI)
    - Upgrading --desktop option from VBScript to a new Win32::Shortcut-based
      Padre::Desktop. Desktop link creation works on Vista and newer
      operating systems again (ADAMK)
    - Tuned menubar refresh to only fire if we change document mimetype,
      which saves a ton of CPU and seems to reduce flicker (ADAMK)

0.54 2010.01.07
    - Added experimental support for clickable filenames in Output panel.
      Currently only matches: <error> at <file> line 5. (PDONELAN)
    - If all files are closed, the function list would ->Hide itself
      permanently and never come back. Resolved (ADAMK)
    - Fix perl interpreter selection (SZABGAB)
    - Updated DBD::SQLite dependency to 1.27 and ORLite dependency to 1.30.
      This should now correctly throw an exception on a corrupt padre.db file
      which will cause an immediate crash at startup with a SQLite-related
      error message instead of a secondary error message complaining about
      missing Padre::DB classes (ADAMK)
    - Moved Padre::HelpProvider::Perl to Padre::Document::Perl::Help to
      prevent plugin classes from being scattered all over the namespace
      tree (ADAMK)
    - Moved Padre::QuickFixProvider::Perl to Padre::Document::Perl::QuickFix
      to prevent plugin classes from being scattered all over the namespace
      tree (ADAMK)
    - During shutdown, be more precise about the order in which we clean up
      and be more careful to ensure that ->Update is NOT disabled, to prevent
      segfaults on Windows from the "disabled update at exit" bug (ADAMK)
    - Added the first PROJECT-backend config_perltidy setting, so that
      projects can for the first time define a project tidy policy. This
      project-specific policy isn't being used by the plugin itself yet,
      but this change clears the way for that kind of functionality (ADAMK)
    - Added config_perlcritic configuration setting, so that projects can
      define perlcritic policies (ADAMK)
    - All tests now run without the need for a visible Padre window (ADAMK)
    - Ticket #756: Wx::Perl::ProcessStream 0.24 solved this issue
      Changed the dependency to 0.24 (SEWI)

0.53 2009.12.23
    - Add initial version of a debugger using Debug::Client (SZABGAB)
    - Fix crashes when running refactor actions when there
      is no document (AZAWAWI)
    - Open resource searches now for user selections (AZAWAWI)
    - The Open resource's OK button is disabled when the 
      search results list is empty (AZAWAWI)
    - Help search (F2) now supports *ALL* installed CPAN modules (AZAWAWI)
    - Fixed "Syntax Check" focus loss bug while switching tabs quickly
      and a syntax error is in one of them (AZAWAWI)
    - Help search does not block when loading a long help topics
      list (AZAWAWI)
    - Ticket #787: Add a test for breakpoints to testsuite (SEWI)
    - Fixed missing mime type guessing that caused new Padre documents to
      default always to Scintilla (AZAWAWI)
    - Landed new multi-resource locking subsystem. Many operations are now
      prevented from refreshing the GUI multiple times. Startup, shutdown,
      open and close multiple files, session changing all much faster (ADAMK)
    - In Open resource, path is now cleaned from slashes on win32 (AZAWAWI)
    - Fixed Padre crash when closing a Perl 5 script tab quickly while syntax
      check is on (AZAWAWI)
    - Added "No errors/warnings to $project-relative-filename" to syntax
      checker. (AZAWAWI)
    - Quick Menu access now displays Padre action label, name and comments
      in an HTML window instead of a static label (AZAWAWI)
    - Make the focus on "Find in files" work when called from Quick menu 
      access dialog (AZAWAWI)
    - Help Search dialog is now bigger in size and fonts. (AZAWAWI)
    - HTML output in help search dialog for Perl variables and functions has now
      bigger bold fonts for title (AZAWAWI)
    - Fixed #758: Autocomplete now also works with backspace (SEWI)
    - Ctrl-Tab behaviour is now configurable (SEWI)
    - Rename Padre::Debug to Padre::Logger (SZABGAB)
    - Reuse the comment field of the menu actions and show them in the toolbar (SZABGAB)
    - Add comment field to all the menu items that did not have yet (SZABGAB)
    - Integrated Padre::DB into the Padre::Locker API, so that we can do
      (very basic) nested transactions (ADAMK)
    - Audited the startup process for database operations that either weren't
      being done in a transaction, or were doing crazy bizarre things. Startup
      is now noticably faster (ADAMK)
    - Added Preference setting to control autocomplete when editting a script rather than
      a Module. (PLAVEN)      

0.52 2009.12.14
    - Add a plugin hook on change of current editor tab (SEWI)
    - Show the svn revision of Padre's start time at the title bar&about dialog,
      not the current one (SEWI)
    - Fixed: Padre command line arguments work again when using dev.pl (SEWI)
    - Fixed: Menu options get disabled/enabled as needed again, this also
      fixed ticket #742, #762, #764 and #771 (SEWI)
    - Alt-Left and Alt-Right switch to the neighbor panels which Ctrl-Tab
      uses the last-used order (SEWI)
    - Fix: Double click on the function list jumps to the sub (again) now (SEWI)
    - Added "Save Intution" to the File menu, to automatically save a new
      file wherever Padre is confident it is appropriate (ADAMK)
    - New file creation is now driven by Template Toolkit templates (using
      Template::Tiny). This should allow even basic new file creation to be
      somewhat adaptive to the user or project context (ADAMK)
    - Padre speedup: Limit number of menu bar refreshs (SEWI)
    - Fixed ticket #790: Ctrl + Caps Lock reduces font size (AZAWAWI)
    - Re-enabled toggle status bar on win32 (AZAWAWI)
    - Fixed ticket #750: Ctrl-Tab works again (PLAVEN, SEWI)
    - Fixed Padre crash in Module Tools/Install Locale/Module/CPAN config (AZAWAWI)
    - Open Resource restarts search now when project directory or Padre's 
      current directory changes (AZAWAWI)

0.51 2009.12.06
    - Find all option showing all matches in bottom tab (CODE4PAY)
    - Improved FTP error handling (SEWI)
    - Open URLs from command line (SEWI)
    - Configurable location of the 'perltags' file for autocompletion (SEWI)
    - Fixed ticket #419: find variable declaration does not work at the end of
      a variable (PATRICKAS)
    - Fixed ticket #654: Lexical Rename of Variable - Can't highlight the
      whole variable (PATRICKAS)
    - Improved "Find Method Declaration" based on perltags (SMUELLER)
    - Basic XS-Document support as needed for the full monty in a plugin (SMUELLER)
    - XS (perlapi) calltips based on the perlapi of 5.10.1 
      by default. Can be configured to show the perlapi of any release of
      perl back to 5.6.0 if Padre::Plugin::XS is installed. (SMUELLER)
    - Padre::Action::Queue for auto-processing of Padre actions (SEWI)
    - Perl autocompletion is much more configurable now (SEWI)
    - Indentation auto-detection now skips POD for ::Perl documents (SMUELLER)
    - Find in Files now has a checkbox that shows files that do not match (GARU)
    - Tests which are not needed for end-user installation now in xt (ADAMK)
    - Added a test for actions (SEWI)
    - Re-enabled the beginner error check tests (SEWI)
    - Better focus transitions during search/replace, which should make
      them easier to work with quickly (ADAMK)
    - Rolled back function list improvements that were causing regressions (ADAMK)
    - Added project sub-path intuition when saving new files (ADAMK)
    - Fixed a number of search/replace related bugs (ADAMK)
    - Fixed ticket #421: crash: no documents, F3/F4 (AZAWAWI)
    - Fixed ticket #678: VACUUM the configuration database at shutdown 
      to keep it small and fast (AZAWAWI)
    - Fixed ticket #714: [Windows] Have a script to make binary. (AZAWAWI)
    - Styles now allow configuring of the selected text (ADAMK)
    - Upgraded tracing to new Padre::Debug that compiles out when not
      being used. (ADAMK)
    - Make Capture::Tiny a test prereq in order to eliminate a strange 
      test failure (SZABGAB).  
    - Added an initial simplistic mime-type + detector for Template Toolkit (ADAMK)
    - Change Directory label to Project to hint to the user that Padre does
      actually understand the concept of a project, it's just subtle (ADAMK)

0.50 2009.11.08
    - Fixed #686 DocBrowser launching Padre help (BRAMBLE)
    - Add initial version of a regex editor. (SZABGAB)
    - Fixed ticket #728: Changing locale crashes Padre (AZAWAWI)
    - Menubar is now configurable but still lacks a dialog for this (SEWI)
    - Beginner error checks are now configurable (turn each single one on
      or off) (SEWI)
    - Fixed ticket #710: share/doc/perlopref.pod missing author/license (AZAWAWI)
    - Added basic FTP-remote-editing capability (SEWI)
    - Initial version of "Find Method Declaration" (SZABGAB)
    - Timeouts an other options for Padre::File::HTTP and ::FTP are now
      configurable (SEWI)

0.49 2009.11.02
    - Fixed #691: Extract subroutine does not work for a script without
      subroutines (PLAVEN)
    - Bugfix: The split-beginner-error check got false positives (SEWI)
    - Moved more menu actions to independent actions (SEWI)
    - Added a readonly flag to the taskbar (AGN)
    - Fixed #698: Syntax checker leaks files in tmpdir (SEWI)
    - Syntax checker now also shows a successful check (SEWI)
    - Added menu option to reload all open files (SEWI)
    - The current selection or document may be filtered through an external
      command now (SEWI)
    - Low-priority popup messages could be moved to the status bar by setting
      a preferences option (SEWI)
    - require IPC::Open2 and IPC::Open3 as they are both used in the code (SZABGAB)
    - Improved autocomplete (always) results (SEWI)
    - Run make and TDD-tests in one step (KTHAKORE)
    - Padre is now an XP-themed win32 application (AZAWAWI)
    - Auto-save session state is now possible (SEWI)
    - Auto completion usability fixes (AZAWAWI)
    - Padre syntax images are now 16x16 transparent PNG images instead of 14x7 
      (AZAWAWI)
    - Fixed ticket:372 "window list should be sorted alphabetically" (AZAWAWI)
    - Added "shorten common path in window list" to preferences (AZAWAWI)
    - Fixed ticket:709 "Show editor window listed by project, then project-
      relative path" (AZAWAWI)
    - Added a test to run Padre's beginner error checks on the Padre source (SEWI)
    - Config option for auto-cleanup of files during save for supported
      document types (SEWI)
    - Modules/Plugins could now add their panels to the global preferences (SEWI)
    - Workaround for Test::NoWarnings hiding issue which lead to missing
      prerequisites or upgrades (#646 SZABGAB)

0.48 2009.10.12
    - "Last session" now restores the last state even if Padre crashed and not
      the last stated saved by a planned exit (SEWI)
    - Fixed Wx::Perl::ProcessStream installation failure on vista/win7 by
      upgrading to 0.16 (AZAWAWI, Mark Dootson - mdootson)
    - Fixed the error dialog so that it displays the error icon (AZAWAWI)
    - Fixed ticket #292: "Split window" command does not work by removing
      the non-working feature (AZAWAWI)
    - Added examples for Perl newbies (SEWI)
    - Added a search field for functions list accessible via ALT-N (AZAWAWI)
    - Added random instance ID (SEWI)
    - Added multiple events per action (SEWI)
    - Fixed win32's context menu key to work exactly as the right click behavior 
      or ALT-/ (AZAWAWI)
    - Fixed ticket #598: CTRL-L kills clipboard (AZAWAWI)
    - Case sensitive was labeled case insensitive in replace, fixed. (SEWI)
    - Windows filename test doesn't run on darwin (Mac) any longer and runs as TODO
      because a failure must not stop the Padre installation. (SEWI)
    - Padre::File::HTTP uses environment settings for proxy (SEWI)
    - First real working version of the PopularityContest - module (SEWI)
    - Smart highlighting works now in realtime as you select text (AZAWAWI)
    - Fixed ticket #611: File | Open does not support UNC path (AZAWAWI)
    - Save session now suggest the name of the last opened session for saving (SEWI)
    - Fixed ticket #627: Suggestion: Make it possible to copy 'Syntax Check'
      messages (AZAWAWI)
    - require version 0.20 of Wx::Perl::ProcessStream to fix #628 (AZAWAWI, SZABGAB)
    - Fixed ticket #493: splash image license not suitable for Debian (AZAWAWI)
    - Fixed t/86-service.t to work again on win32 (AZAWAWI)
    - Fixed ticket #314: Padre broken on MS Vista when starting with no file
      to be opened (AZAWAWI)
    - Added a 'padre --desktop' option that improves Padre-Windows integration.
      This creates a desktop shortcut and an "Edit with Padre" in the shell 
      context menu (AZAWAWI)
    - Made beginner error checks report the line where an error was located (SEWI)
    - Fixed: Syntax checker now only shows errors from current file (SEWI)
    - padre --version displays a MessageBox under wperl.exe (AZAWAWI)
    - Option to continue on beginner errors (SEWI)
    - Made title bar configurable (SEWI)
    - Autocomplete on every char (enable it in the preferences) (SEWI)
    - Add logfile so the developer debugger of padre will print there
      and not on STDERR. (SZABGAB)
    - Show file size on disk in statistics (SEWI)
    - Under Linux and BSD, 'padre --desktop' adds a Padre.desktop inside
      /usr/share/applications (AZAWAWI)
    - When saving a module for the first time, Padre will attempt to guess the
      name of the file so you don't need to type it (ADAMK)
    - Added "Dump Expression" to Developer Plugin to evaluate and dump a single
      expression within the Padre context (ADAMK)
    - Perl interpreter for running scripts is now configurable (SEWI)
    - Added MIME type count to PopularityContest, but it's still not sending
      anything (SEWI)
    - Added a runnable-flag to Padre::File and it's current modules (SEWI)
    - Syntax check now doesn't slow down typing (SEWI)
    - Add autocomplete feature for new methods (SEWI)
    - Update directory tree on load session (SEWI)
    - New Padre launcher for Windows (DOLMEN)
    - Fixed Open Resource status text display on Linux (AZAWAWI)
    - Added configuration version checking and prepared auto-config-upgrades (SEWI)
    - The Perl help search (F2) destroyed the code refernce calling it, so F2
      was usable only once per Padre start, may also apply to other actions.
      Fixed. (SEWI)
    - Ticket #660 - Moved Perl Refactoring tools to it's own Refactor Menu (PLAVEN)
    - Added the ability to select where to place the "extracted subroutine" in the current
      document (PLAVEN)

0.47 2009.09.25
    - Bundled more Perl Operators documentation [perlopref.pod] (AZAWAWI, COWENS)
    - Fixed crash when inserting a special value without any document (AZAWAWI)
    - Improved StatusBar - speed (SEWI)
    - Fixed ticket #573 ESC does not close About window (AZAWAWI)
    - Fixed ticket #578 Padre's Splash screen should not get in the way (AZAWAWI)
    - Fixed ticket #579 Commenting/uncommenting comments the last unselected 
      line (AZAWAWI)
    - Fixed ticket #576 common (beginner) error check has no feedback if no
      errors found (AZAWAWI)
    - Added Padre::File as a API for all operations on edited files (SEWI)
    - Added 13-eol.t to detect non-UNIX EOL-ed files in Padre (AZAWAWI)
    - Added "Open URL" menu option (SEWI)
    - Added Padre::File::HTTP (SEWI)
    - No more "WIN32" as a line ending indicator only "WIN" (AZAWAWI)
    - The status bar provides more space to display longer mime-type names (AZAWAWI)
    - The status bar reflects now the current document's line endings as
      follows (AZAWAWI):
        - WIN (CR/LF), MAC (CR), UNIX (LF)
        - Mixed, a mixture of the above which is usually an error
        - None which is a one-liner/empty script
    - Beautified the about dialog so that it is includes the splash image. (AZAWAWI)
    - Fixed ticket #589 Pasting in a UNIX document in win32 corrupts it to
      MIXEd (AZAWAWI)
    - Added more beginner-error-checks (SEWI)
    - Improved Perl menu to be more consistent (AZAWAWI)
    - Fixed ticket #504 and ticket #586 which are basically about being able to
      lexically rename a variable when the cursor is over its declaration (AZAWAWI)
    - Added "Dump PPI Document" to "Padre Developer Tools" core plugin (AZAWAWI)
    - Added Run/Stop icons to the toolbar per ticket #529 (AZAWAWI)
    - Fixed ticket #595 F6 (Stop Executing of script) doesnt work with Output
      window in Windows (AZAWAWI)
    - Fixed ticket #597: Merged OS detection in Padre::Constant (SEWI)
    - Fixed ticket #594: F1 key doesn't work (SEWI)
    - Fixed ticket #593: On Windows, files with / and \ are now the same
      and files are treated case-insensitive (AZAWAWI, SEWI)
    - Fixed ticket #591: Save/Save as decision was corrupt (SEWI)
    - Fixed ticket #582: Run this test/Run Tests are broken on win32 when there
      is a space in the test file (AZAWAWI)
    - Fixed ticket #553: Directory browser's "Move to trash" feature is not
      working on Vista/win32 (AZAWAWI)
    - Massive refactoring of Plugin Manager. Looks almost exactly the same
      but now the status information actually updates properly (ADAMK)
    - Added a padre.exe launcher on win32 (SEWI, GETTY, AZAWAWI)
    - Reformat filenames to correct OS-dependend syntax (AZAWAWI, SEWI)
    - Moved add Win32 API functions to one module (AZAWAWI, SEWI)
    - Fixed ticket #488: allow script to recognize when executed by Padre (AZAWAWI)
    - Padre now uses cperl() console instead perl() for compatiblity with
      wperl (AZAWAWI)
    - Added Perl version, uptime and process information to about box (SEWI)
    - Fixed ticket #603: Background tasks fail to work under wperl win32 (AZAWAWI)
    - Added option to open a saved session on startup (SEWI)
    - Fixed ticket #580: On win32, Perl 5 syntax checker is invoked in strange 
      situations (AZAWAWI)
    - Padre now warns about the running process at exit and asks whether to kill 
      it and exit or cancel the shutdown (AZAWAWI)
    - Removed false warnings about duplicated actions/shortcuts when changing 
      Padre's language (AZAWAWI)
    - Fixed ticket #394: Close DocBrowser with Escape key (AZAWAWI)

0.46 2009.09.13
    - Fixed Smart highlighting to show a pale green round box instead of an 
      ugly squiggle (AZAWAWI)
    - Run script waits now after completion for key to continue when run in an
      external win32 window (AZAWAWI).
    - Padre now supports the following extensions:
        - For Perl 5, .pmc and .plx (AZAWAWI, SZABGAB)
        - For Perl 6, .pl6, .pm6, .p6l and .p6m (AZAWAWI)
    - Help search handles now http:// and perldoc:// links (AZAWAWI)
    - Enabled "Syntax Check" tab is now shown when there is a problem without
      losing editor focus (AZAWAWI)
    - Handle "Recent files" Padre crash when it is called with a file that no 
      longer exists. The entry is deleted and a message box is shown (AZAWAWI)
    - Added a "extract subroutine" function (RHEBUS)
    - Handle "Open all Recent Files" Padre crash when setup_editor is called 
      with a file that no longer exists (AZAWAWI)
    - Fixed ticket #536 Padre auto converts EOLs automatically (AZAWAWI)
    - Pod::Perldoc 3.15 is required now. Allowing help on $. and similar. (AZAWAWI)
    - Fixed Arabic/Hebrew developer/translator names in Padre's about box (AZAWAWI)
    - Bundled more Perl Operators documentation [perlopref.pod] (AZAWAWI, COWENS)
    - Made beginner-error-checks work (SEWI)

0.45 2009.09.02
    - Disabled 'Test Plugin From Local Dir' menu option until it's properly fixed (GARU)
    - Fixed PluginManager Pod glitch for deprecated Perl5 plugin (ADAMK)
    - Fixed various open bugs which exist on Gnome but not on Windows (SEWI)
    - Several translation updates (thanks to all translators!)

0.44 2009.08.24
    - Help Search now supports perlopref.pod parsing - Perl operator reference 
      (AZAWAWI)
    - Fixed various "Help Search" dialog bugs for perlvars and CORE modules 
      (AZAWAWI)
    - "Directory Browser" stability fixes (AZAWAWI)
    - Refactored "Help Search" to use document help providers. This will make it
      faster (AZAWAWI)
    - Help Search looks up words selected or under the cursor (AZAWAWI)
    - allow the use of $main->open_file_dialog($dir) (SZABGAB)
    - Moved Ecliptic's Quick Fix to Padre core under the Edit menu (AZAWAWI)
    - Enable the F12 Save as shortcut again (SZBAGAB)
    - Added Perl 5 Quick Fix for 'use strict; use warnings;' (AZAWAWI)
    - Added Insert submenu and dialog, moved snippets into insert submenu (TEEJAY)

0.43 2009.08.16
    - Revised nice splash screen slightly. Move original artwork
      to Padre-Artwork (BRAMBLE)
    - Added a (hopefully) nice splash screen for Padre (GARU)
    - Added a Padre::Perl API for discovering the location of the system
      Perl in a way smart enough to handle people that specifically need a
      command line Perl, or specifically need a windowing Perl (ADAMK)
    - Temporarily remove PAR support (ADAMK)
    - Upgrade the plugin internals to support arbitrary class names,
      simplifying the implementation and clearing the way for
      Acme::Padre::Plugin::* modules. (ADAMK)
    - Updated PPI dependencies. Padre now supports 5.10 syntax in PPI-based
      features (ADAMK)
    - Find dialog now uses the Padre::Search API. (ADAMK)
    - New multiple-tabbed About box (ADAMK)
    - F3 with sub-line selected text converts it directly into an active
      search without needing to invoke the Find dialog (ADAMK)
    - Moved Perl 6 Help dialog to Padre core as "Help/Help Search" (AZAWAWI)
    - Help/Help Search now supports Perl 5 (AZAWAWI)
    - Moved Ecliptic's Open Resource to Padre core as "Search/Open Resource" 
      (AZAWAWI)
    - Moved Ecliptic's Quick Menu Access to Padre core as "Search/Quick Menu 
      Access" (AZAWAWI)
    - Fixed run command in a separate window bug on win32 (AZAWAWI)
    - Moved Ecliptic's "Open in file browser" to Padre core as "File/Open in 
      File Browser" and integrated it with Directory browser (AZAWAWI)
    - Moved functionality in Perl 5 plugin to Plugins -> Module Tools (ADAMK)
    - Implemented "Edit / Next Problem" (AZAWAWI)
    - Force setting of document (MIME) type when using New->Perl 5 test 
      (#476) (KARL.FORNER) (SZABGAB)
    - Make sure coloring is update when save-as file or when opening a new
      file from template. (SZABGAB)

0.42 2009.07.31
    - Fixed a bug that crashed Padre while moving panels with outline
      enabled (GARU)
    - The Directory browser hidden files support now automatically
      recognises intermediate directories (blib etc) in Perl distributions,
      and correctly ignores them (ADAMK)
    - Various performance improvements to directory tree (ADAMK)
    - New search engine coupled to directory tree with some regex
      characters support (GABRIELMAD)
    - Initial Padre actions support which means an action can be re-used 
      by anything running on Padre. Keyboard shortcut conflict warnings are
      implemented (AZAWAWI)
    - Added the "Artistic" and "COPYING" (GPLv1) files as well a note to the
      "README" about licensing per the request of the 
      http://directory.fsf.org/ maintainers. (SHLOMIF)
    - Added a "right margin" option which will show a line at the specified
      column (BRICAS)
    - Now new files belong to the project from where they were created till
      they are saved (GABRIELMAD)
    - Directory Tree shows the project directory or if none file is opened
      the default projects directory (configurable in Preferences > Behavior
    - none configured, default is user's documents directory) (GABRIELMAD)
    - Install some of the examples in the share directory and add an
      Open Example menu option (SZABGAB)
    - Adding Padre::Wx->add_pane_info convenience method to prevent the need
      for the stupid ugly Wx::AuiPaneInfo method chaining (ADAMK)
    - Create the Left panel and moved the Directory tool into it (ADAMK)
    - Upgrade Wx tree navigation to handle detached floating panels (ADAMK)
    - Implemented Smart Highlighting. Double click on a word to select it
      and a green squiggle will be shown for each matching word (AZAWAWI)
    - Now users can choose which is the project directory that Directory
      Tree must show (GABRIELMAD)
    - Moved close operations into Close... submenu (ADAMK)
    - Added "Close This Project" to close all open files in the same project
      as the current file (ADAMK)
    - Added "Close Other Projects" to close all open files in projects other
      than the project of the current file (ADAMK)
    - Changed a bunch of documentation from using items or comma-separation
      to using =head3 pod entries (ADAMK)
    - Adding new Blue Morpho logo (ADAMK)
    - Removed dependency on prefork.pm, it was only there to shut up the dev.pl
      DIE: warnings (ADAMK)
    - Removed dependency on Test::Most, and with it about 5-10 other excessive
      test-related dependencies (ADAMK)

0.41 2009.07.23
    - Remove Experimental mode.
    - Fixed a bug in Plugin config_write where ->selectrow_array was used 
      instead of ->do to SQL update (Thanks to tlbdk++). (AZAWAWI)
    - run_command in a separate window now works in win32 to support 
      prompt('...') in Perl 6 and <STDIN> in Perl 5. (AZAWAWI)
    - Now Padre can find/replace inside selections (GARU)
    - New Syntax highlighter configuration system. Plugins now can add more
      syntax highlighters and users can pick one per mime-type. (SZABGAB)
    - Directory browser new artwork and drag and drop support (GABRIELMAD)

0.40 2009.07.17
    - Removed about 10 dependencies, including several with lots of FAIL
      reports in CPAN Testers (ADAMK)
    - Complete refactoring of the Directory Browser, gaining a lot of 
      performance improvements and new features such as sorted output
      and context menu options (GABRIELMAD)

0.39 2009.07.09
    - Some of the refactoring code was moved to PPIx-EditorTools (MGRIMES)
    - Detection of Moose attributes in Outline view (JQUELIN)
    - Detection of MooseX::POE events in Outline view (JQUELIN)
    - Added keywords to META.yml (via Makefile.PL.) (SHLOMIF)
    - Bumped the required Test::More version to 0.88 - needed for note().
      (SHLOMIF)
    - Open Selection (ctrl-Shift-O) now displays all the files it finds
      and lets the user select (SZABGAB)
    - Eliminate crash when pressing F3/F4 while there are no open
      files (#421) (SZABGAB)
    - Enable/Disable Window menu options when there are (no) open
      files. (#417) (SZABGAB)
    - For Cut/Copy/Paste/Select All, use the focused textctrl instead
      of the editor textctrl (RSN)
    - Autoupgrade ascii files to be utf-8 on save if user types in wide
      characters (#304) (SZABGAB)
    - Allow the user to use external (xterm) to run the scrips. (SZABGAB)
    - Add menu option to show selection as hexa or as
      decimal. (#36) (SZABGAB)
    - Switch to Locale::Msgfmt and generate the .mo files at install
      time (RSN)
    - Add number of lines to GoTo line dialog (#439) (SZABGAB)

0.38 2009.06.27

    - Replace regex that needs 5.10 by a split (SZABGAB)

0.37 2009.06.25
    - "Introduce Temporary Variable" refactoring tool (SMUELLER)
    - Added a friendly icon on the toolbar to toggle comments (GARU)
    - Crazy Win32::API AllowSetForegroundWindow hack to allow the
      Single Instance Server to correctly foreground itself (ADAMK)
    - Added Padre::Search search and replace API (ADAMK)
    - Switching to last edited file is now Ctrl-Shift-p (SZABGAB)
    - Be compatible with older version of File::Path (RYAN52)
    - Links to Mibbit were replaced by links to our irc.html (SZABGAB)
    - Merged the code of Padre::Plugin::Encode into Padre (SZABGAB)
    - Update directory only when switching to new editor (SZABGAB)

0.36 2009.05.30
    - DocBrowser::POD resolver is now Pod::PerlDoc with benefits
      DocBrowser attempts to use current padre locale as language hint
      DocBrowser reuses tabs for same/similar documents (#323) (Andrew Bramble)
    - Make DocBrowser suck less. Quieter and faster (#322) (Andrew Bramble)
    - Output should be blank by default at startup (#351) (JQUELIN)
    - No padre version in window title (#349) (JQUELIN)
    - Added generic HTTP task support with Padre::Task::LWP (ADAMK)
    - Implemented first-generation Popularity Contest task (ADAMK)
    - Reorganized and differentiated Find and Replace dialogs (#348) (THEREK)
    - Add a set of filename wildcards to filter directory listing in Open File dialog (#343) (THEREK)
    - Add Chinese (Traditional) translation (BLUET)
    - Show Perl menu on a Project as well as Document basis (ADAMK)
    - Disable all Perl 6 code unless the Perl 6 plugin is enabled (ADAMK)
    - Reshuffle and relabel of some menus to improve asthetics (ADAMK)
    - Fix no_refresh during multi-file operations (ADAMK)
    - Added mibbit.com "Live Support" entries to the Help menu (ADAMK)
    - Removed the use of Class::Autouse, it was slowing down PPI (ADAMK)
    - Various performance improvements, load cost down by 12Mb (ADAMK)
    - Fixed the cut/copy/paste problem (#332) (ADAMK)

0.35 2009.05.08
    - Add Japanese translation (ISHIGAKI)
    - Implemented experimental Single Instance support (#117) (ADAMK)
    - Implemented context-sensitive right-click menu for Perl documents (SMUELLER)
    - Ctrl-left-click on a Perl variable will jump to its definition (SMUELLER)
    - Ctrl-left-click on a Perl function callwill jump to its definition (SMUELLER)
    - Left-clicks into documents can now be hooked by the document class (SMUELLER)
    - Fix to the thread-status display (SMUELLER)
    - Fixed ticket #300: disabled EVT_SET_FOCUS in preview (THEREK)
    - Fixed ticket #289: Scrolling in preference window (PZSCHMIDT)
    - Fixed ticket #301: Fix wx assertion failures (JQUELIN, SMUELLER)
    - Launching a browser now happens in the background (ADAMK)
    - Add Czech translation

0.34 2009.04.28
    - Fix crash in plugin manager when changing locale while window opened (#298) (JQUELIN)
    - Support for plugin l10n in place (JQUELIN)
    - Added Preferences->Run Parameters panel instead of Perl->Run Parameters menu option. (THEREK)
    - Stop refreshing the menues on every keystroke. Instead when the menu is being accessed. (SZABGAB)
    - Sessions support (#123) (JQUELIN)
    - Enable tooltips on the toolbar on Windows as well (SZABGAB)
    - Fix localization change in the Syntax window (#198) (SZABGAB)
    - Plugin manager correctly localized at startup (JQUELIN)
    - Plugin manager displaying full plugin names (JQUELIN)
    - Set file size limit to 500_000 to avoid loading too big files. (#186) (SZABGAB)
    - Double-clicking on an error now selects the line (#214) (JQUELIN)

0.33 2009.04.04
    - Fix bug in relative path showing in the Windows menu. (GARU)
    - Fix the swicthing between ppi mode and none-ppi mode (SZABGAB)
    - Stop forking at startup. (SZABGAB) 
    - Skip the win32 subtests if the locale is not English. (SZABGAB)
    - Added debug logging that can be turned on/off via the Developer plugin. (SZABGAB)
    - Simplified Chinese translation turned on. (FAYLAND, SZABGAB)
    - Added Polish translation. (THEREK)
    - Revamped plugin manager. (JQUELIN)

0.32 2009.03.29
    - Trying to fix again the skipping of Padre::CPAN under the CPAN shell.

0.31 2009.03.29
    - Avoid creating the ~/.padre during testing by two more tests. (SZABGAB, thanks to AYILMAZ)
    - Skip testing Padre::CPAN as it cannot be loaded under CPAN. (SZABGAB, thanks to AYILMAZ)
    - Fix the Directory browser to switch between projects. (SZABGAB)
    - Add "Run Tests" menu options to, err run tests. (SZABGAB)
    - Work around painful segmentation faults from multiply freeing
      AuiManagers (SMUELLER)
    - Lexical variable replace works for arrays and hashes in all their
      ugly incantations now (SMUELLER)
    - Re-enable the taskmanager tests after fixing them. (SMUELLER)

0.30 2009.03.27
    - Remove Test::Compile from the prereqs as well as it is not in use. (SZABGAB)
    - New GUI for selecting and installing CPAN modules. (SZABGAB)
    - CPAN related menu items moved to new Perl5 plugin (SZABGAB)
    - (Re-)Storing cursor position in file (#206) (JQUELIN)
    - Reload file keeps cursor position (#220) (JQUELIN)
    - Preferences windows title should match its menu invocation (#270) (JQUELIN)
    - Fix error if passed a non-existent filename on command-line (#155) (JQUELIN)
    - New task_warn/task_print methods in background tasks to easily
      print to the output pane (SMUELLER)
    - Fix bug in lexical variable declaration search that would prevent
      it from finding variables declared in the main doc scope (SMUELLER)
    - Lexical variable replace works for foreach my $foo too. (SMUELLER)

0.29 2009.03.13
    - Initial support for directory browser based on the Outline code (SZABGAB)
    - Improving Padre::Util::get_project_dir (SZABGAB)
    - Eliminate a test failure on non-English locale. (SZABGAB)
    - Internal cleanups & documentation for configuration subsystem (JQUELIN)
    - Require Test::Most for the testing and bail_on compilation errors. (SZABGAB)
    - Eliminated a huge memory leak by not updating the plugin menu on every keystroke. (SZABGAB)

0.28 2009.03.04
    - Move Wx::Perl::Dialog back to the Padre tree. (SZABGAB)
    - Allow the shortening of the the file list in the Window menu. (SZABGAB)
    - Fix Ctrl-TAB and Ctrl-Shift-TAB. (SZABGAB)
    - List the available perldiag translations and allow the user to change. (SZABGAB)
    - Fix a few missed cases of the API change. (SZABGAB)
    - Some sharedir improvement. (SMUELLER)
    - List of available perldiag translations. (SZABGAB)
    - Add prompt method to be used by plugins as well. (SZABGAB)

0.27 2009.02.10
    - Copyright changed to "The Padre development team as listed in Padre.pm." (SZABGAB)
    - Some fixes in the search menu.
    - Improve file type (Perl 5 / Perl 6 ) recognition. (SZABGAB)
    - Fix the Windows menu to be able to jump to files. (SZABGAB)
    - Statusbar visibility kept accross startup (#200). (JQUELIN)

0.26 2009.02.01
    - On X11 based platforms, selecting text using the mouse and pasting it
      via middle mouse button now works (HJANSEN)
    - Unifying Padre->inst and Padre->ide (ADAMK)
    - Complete rewrite of the configuration layer. All access to configuration
      data is now via methods so that we can add support for project-level
      customisation of the interface. (ADAMK)
    - Completely refactored all of the config setting names (ADAMK)
    - Added first-class configuration support for Plugins (ADAMK)
    - Moved config data on bookmarks, plugins and historical search/replace
      strings out of the config file and into the database. (ADAMK)
    - The output window now understands the color and font-face
      related ANSI control sequences (SMUELLER)
    - The long-awaited MainWindow.pm -> Main.pm (ADAMK)
    - Heavily modified many variables and method names to bring a greater
      simplicity and consistency to various APIs. Only possible because
      we were already breaking the config system and Main.pm (ADAMK)
    - Removed some classes and other code that had (astonishingly for such a
      young application) become useless and bit-rotten (ADAMK)
    - Added styles for text/x-patch, text/x-makefile, text/x-yaml,
      text/css, text/plain(apache conf) file types (KEEDI)
    - Now style config file supports foreground, background, bold,
      italic, eolfilled, underline properties (KEEDI)
    - Output window now uses mono-spaced font by default (SMUELLER)
    - The 'Crashed' button in the plugin manager dialog is now
      clickable if an explanation for the failure is
      available (SMUELLER)

0.25 2009.01.09
    - Added Chinese (Simplified) translation (FAYLAND)
    - Various subtle tweaks to the look and feel of the toolbar and
      the panels. The GUI now looks noticably "sharper" (ADAMK)
    - Expanded the variety and depth of functionality available in the
      bundled "Padre Developer Tools" plugin (ADAMK)
    - Our unattributed redistribution of tango was probably illegal,
      and made us incompatible with Debian. Switch to gnome for
      now. They are as ugly as sin, but at least they're legal (ADAMK)
    - All big MainWindow gui elements are now in their own classes,
      which should help us spread out feature logic properly (ADAMK)
    - Moved Padre::Plugin::CPAN functionality into the core so that
      we can do various sorts of tighter CPAN integration (ADAMK)
    - Padre::Wx::DocBrowser now uses Padre::Task::DocBrowser (let's 
      hope properly) (Andrew Bramble)
    - Class correction Padre::Wx::Menu -> Padre::Wx::Menubar (ADAMK)
    - Class correction Padre::Wx::Submenu -> Padre::Wx::Menu (ADAMK)
    - Now that Padre::DocBrowser has landed, delete the Padre::Pod
      family of modules (ADAMK)
    - Automatic indentation style detection now the default (SMUELLER)
    - User interface now "locked" by default (SMUELLER)
    - Updated Italian translation (SBLANDIN)
    - Addition of contextual (un-) commenting (CLAUDIO)

0.24 2009.01.06
    - Double-clicking an entry in the function list now faithfully
      matches the behaviour of the Ultraedit implementation (ADAMK)
    - Updated German translation (HJANSEN)
    - Replace Padre::Pod::Frame with Padre::Wx::DocBrowser, hopefully
      making help more helpful. (Andrew Bramble)
    - Moving to the glorious RFC4646-based second-generation Padre::Locale
      implementation. "Portugese" is no longer Brazilian :) (ADAMK)
    - Added a friendly icon to the ToolBar that displays the status
      (idle, running, high load) of the background tasks (SMUELLER)
    - Created Padre::Current, which should simplify everything that needs
      to know about the current whatever (ADAMK)
    - Used Padre::Current to kill off the slightly out of place non-class
      Padre::Documents (ADAMK)
    - View Document As... (FAYLAND)

0.23 2009.01.04
    - Updated Italian transation.
    - Refactored the plugin state hash out into a standalone
      Padre::PluginHandle class (ADAMK)
    - Add naive way to locate some of the annoying errors beginners
      might make that perl does not catch. (SZABGAB)
    - Makefile.PL tricks EU:MM into not loading every single dependency,
      making our dependency-heavy Makefile.PL far saner (ADAMK)
    - Portuguese (Brazilian) translation added (GARU)
    - Spanish translation added (PacoLinux)
    - Shutdown process now delays saving the session until after the
      interface phase (ADAMK)
    - Shutdown process now disables all the plugins, so they have a
      change to shut down elegantly too (ADAMK)
    - Plugins now reload correctly (ADAMK)
    - Created a basic stub Padre::Manual and moved the information in
      HACKING.txt into Padre::Manual::Hacking and
    - Padre::Manual::Translation (ADAMK)
    - Moved more bits of GUI code out of MainWindow and into their own
      classes (ADAMK)

0.22 2008.12.23
    - Various Perl6 and Parrot related snippets of code and
      functionality have been moved to the respective
      plugins (SZABGAB and others)
    - Extended preference dialog with tabs (HJANSEN)
    - Syntax checker now running in the background (SMUELLER)
    - Background Tasks can now prevent execution in the prepare
      hook (SMUELLER)
    - Added interface for passing events from worker threads to the
      main thread (SMUELLER)
    - Added simple example of a Task that sends events to the
      main thread (SMUELLER)
    - Tab/Space conversion only converts at the start of each
      line now (SMUELLER)
    - Improved comment/uncomment_lines for HTML/XML (FAYLAND)
    - Rewrote Padre::Wx::Dialog::PluginManager to interact directly with
      Padre::PluginManager (and not talk to Padre::Config) (ADAMK)
    - Migrated Padre::DB to use ORLite::Migrate instead of the
      (increasingly slow) ->setup method (ADAMK)
    - Allow several coloring styles, add style called 'night' (SZABGAB)
    - Right-click menu in margin column for code folding now
      allows to fold/unfold all foldable areas (HJANSEN)
    - Error list window for run-time errors and diagnostics (PSHANGOV)
    - Arabic translation added (AZAWAWI)
    - Italian translation updated (SBLANDIN)
    - Improved Ack (FAYLAND)
    - Allow selection of editor font and current line background 
      color (HJANSEN)
    - Hebrew translation updated (SHLOMIF)
    - Upped Encode requirement to 2.26, fixes some fatal errors with unicode (TEEJAY)
    - binmode fix for File::Temp" in SyntaxChecker.pm (TEEJAY)

0.21 2008.12.14
    - Note: If you are having issues running Padre after upgrading to 0.21,
      ("Gtk-CRITICAL **: gtk_window_set_modal: assertion `GTK_IS_WINDOW (window)' failed")
      try moving or deleting your $HOME/.padre directory and check
      whether that fixes the issues. YMMV and let us know about any
      problems.
    - Now using Module::Install for building (ADAMK, SMUELLER, SZABGAB)
    - Fixed bookmark-related crash (#172) (SvenDowideit)
    - Fixed syntax-checker related focus glitch (#173) (SvenDowideit)
    - Removed JavaScript plugin from the main distribution (SZABGAB)
    - Major menu refactoring. Each menu is now implemented in a seperate
      class, with independant ->refresh methods and much improved
      encapsulation as a result. (ADAMK)
    - Rewrote the Padre bootstrap sequence. Not only does Padre start in
      a more sane order, but with some additional tweaks using
      ->Show, ->Freeze and ->Thaw, Padre LOOKS like it starts up
      and shuts down much much faster (ADAMK)
    - Reorganised the order and seperators for the View menu (ADAMK)
    - The Plugins menu no longer shows separators that don't separate
      anything (ADAMK)
    - Padre's lib directory now passes all of the rules in Perl::Critic's
      default Severity 5 policy. (ADAMK)
    - Changed the names of a number of Padre::Wx::*** classes to more-closely
      match the underlying Wx::*** classes that they subclass. (ADAMK)
    - Option to always auto-detect indentation style and adapt for each
      open document. (SMUELLER)
    - Default to showing functions in alphabetical order. (SMUELLER)
    - Option to show functions in alphabetical order, except private methods
      go last. (SMUELLER)
    - A bunch of autoindentation fixes. (SMUELLER)
    - AUI updates to the syntax-checker/output-window GUI elements (HJANSEN)
    - Various portability and miscellaneous fixes to the syntax checker
      (ADAMK, HJANSEN)
    - Add new Perl-specific feature: "Jump to variable declaration"
      and the experimental "replace lexical variable". (SMUELLER)
    - The Perl-specific "find unmatched brace" feature now processes
      the document in the background. (SMUELLER)
    - Generic Padre::Task::PPI class with tools for PPI-related
      background tasks. (SMUELLER)
    - Experimental implementation of the Padre::TaskManager thread pool
      and Padre::Task background-task-interface for running blocking
      tasks in additional threads. (SMUELLER)
    - Italian translation (SBLANDIN)
    - Show methods in abc order. Allow user to set preference to 'abc' or 'original'
      ordering of methods. (#163) (SZABGAB)
    - Open selection prompts user if nothing selected. (#143) (JQUELIN)
    - Russian translation added (Andrew Shitov)
    - Dutch translation added (Dirk De Nijs)
    - Lots and lots of encoding tweaks.

0.20 2008.12.02
    - Separate tab-width from indentation-level preference (SMUELLER)
    - Expend auto-detection of indentation style to include the
      indentation level (SMUELLER)
    - Apply automatic tab-compression if tab-indentation is used with
      an indentation-width != tab-width (SMUELLER)
    - Reworked the autoindentation: Now with auto-de-indentation on
      closing brace (SMUELLER)
    - Now using Class::XSAccessor for generating accessors (SMUELLER)
    - Moved the syntax checker from Main.pm into
      Padre::Wx::SyntaxChecker (SMUELLER)
    - Small improvement to startup time by not refreshing the plugin
      menu after loading each plugin (SMUELLER)
    - French translation added (JQUELIN)
    - Some refactoring, (SZABGAB)
    - Display error when reload file failed. (SZABGAB)
    - Korean updates. (KEEDI)
    - Hungarian updates. (GYU)
    - Fix the "cannot save new file bug". (TEEJAY)
    - Save files under Mac. #160 (ChrisDolan)
    - Restore inner window layout through restart. (HJANSEN)

0.19 2008.11.28
    - Korean translation added (KEEDI)
    - Hungarian translation added (GYU)
    - Hebrew translation added (Omer Zak)
    - Improvement in vi Plugin (SZABGAB)
    - Locale switching no longer needs a restart (HJANSEN)
    - Moved syntax checking out from experimental state (HJANSEN)
    - Prototype of printing support (HJANSEN)
    - Adding support for document type registration (ADAMK)
    - Adding plugin_name to the Padre::Plugin API (ADAMK)
    - Advancing the version numbers of some prereqs (ADAMK)
    - Save files in the same encoding as they were read.

0.18 2008.11.23
    - Added a few more directories to the no_index list in Build.PL (ADAMK)
    - Implement a reusable Padre::Pod2HTML class so that Padre can develop
      a specific look and feel for all HTML generated from Pod. (ADAMK)
    - Aggresively bump the Pod::Simple dependency so that the generated
      HTML contains support for all the latest developments. (ADAMK)
    - Add explicit dependency on HTML::Entities because Pod::Simple
      has now made the dependency optional. (ADAMK)
    - Aggressivly bump the HTML::Parser dependency so that we have
      better support for our Unicode-needing users (ADAMK)
    - Recognize when file is changed on disk (#55) (JQUELIN)
    - Un/Comment now filetype-dependant (#26) (JQUELIN)
    - Moving the vi keybinding code to a Plugin (SZABGAB)
    - Jump to the last open window using menu or Ctrl-6 (#137) (SZABGAB)
    - Hide the margin of the syntax checker when it is not in use. (SZABGAB)
    - Save-as updates the window menu (#145) (JQUELIN)
    - Drag and drop file(s) open them (#42) (SZABGAB,JQUELIN)
    - padre --index no longer crashes (#79) (JQUELIN)
    - Incremental, non-intrusive search a-la Firefox (#60) (JQUELIN)
    - New Plug-in system, incompatible with the previous one.
    - Plug-in manager dialog.
    - Rename Padre::Plugin::MY to Padre::Plugin::My.

0.17 2008.11.17
    - Optional highlighting of current line (via background color) (HJANSEN)
    - Code folding (#61) (HJANSEN)
    - Word Wrap and "Default word wrap on for each file" in Preferences (FAYLAND)
    - Show/Hide Output or Functions (FAYLAND)
    - Fix the failing plugin manager test. (SZABGAB)
    - Add configuration option to the autoindentation (no, same_level, deep). (SZABGAB)
    - Switch to File::ShareDir::PAR 0.03. (SZABGAB)
    - Allow opening multiple files at once (#43) (JQUELIN)
    - Add Padre::Plugin::MY and set it to be a prefered plugin. (SZABGAB)
    - Join lines with Ctrl+J (#128) (JQUELIN)
    - Full screen view (#131) (JQUELIN)
    - Hide/show white spaces and tabs (#132) (JQUELIN)
    - Check minimum App::Ack version (#104). (JQUELIN)
    - Selection markers to ease selection (#133) (JQUELIN)
    - Drag-n-drop files from Filer Explorer (CORION)
    - Add experimantal and basic vi mode. (SZABGAB)
    - Fix Shift-TAB (#141) (SZABGAB)
    - Add the beginning of second generation plugin support. (ADAMK)
    - Limit the plugin names to one deep only. Second level
      namespaces are saved for the implementation details. (SZABGAB)
    - Experimental perl -c based syntax checking. (HJANSEN)
    - Clean recent files list (#126). (FAYLAND)
    - Open all recent files (#125). (FAYLAND)
    - Alt-1, Alt-2, etc removed. (#122) (SZABGAB)
    - Initial Javascript support. (FAYLAND)
    - Enable/Disable the subs window via View menu (#100).
    - Move between the editor, the output window
      and the subs window with some hot-key (#14) (SZABGAB)

0.16 2008.11.09
    - Fix New on the Toolbar (SZABGAB)
    - Add Diff menu item to show changes in file. (SZABGAB)
    - Change windowing system to AUI solving several requests: (SZABGAB)
      Split view
      Tab reordering
      Tab close button
    - Localization and German translation. (HJANSEN)
    - Move the content of Padre::Wx::Dialog to Wx::Perl::Dialog 0.02 (SZABGAB)
    - Change back the new-file hot-key to be Ctr-N again. (SZABGAB)
    - Add experimental PPI based Perl5 syntax highlighting (FAYLAND, SZABGAB)
    - Save cursor position between runs of Padre. (FAYLAND)
    - Tab/space conversion menu items. (FAYLAND)
    - Upper/Lower case conversion menu items. (FAYLAND)
    - New icons on the toolbar adding undo/redo/cut/cop/paste/select all. (HJANSEN)
    - Also put cut/copy/paste/select all in the edit menu and in the right click menu. (HJANSEN)
    - Move Parrot plugin to separate distribution. (SZABGAB)
    - Enable switching between German and English. (SZABGAB)

0.15 2008.11.02
    - Don't let opening file that is already open. (SZABGAB)
    - Start UTF-8 support. (SZABGAB)
    - Switch to File::ShareDir::PAR (SMUELLER)
    - Start using File::Which to locate the perl interpreter
      (if padre is running from a par archive). (SZABGAB)
    - Fix the Split Window menu option to really work. (SZABGAB)
    - Adding "Close All but Current" menu option. (SZABGAB)
    - Add autoindentation. (SZABGAB)
    - Set focus on windows. (SZABGAB)
    - Before saving, check if file has changed on disk. (SZABGAB)
    - New menu option: "Reload file". (SZABGAB)
    - Move style definition to external yaml file. (SZABGAB)
    - Separate highlighting definition for PASM files. (SZABGAB)
    - Reorganize Menus (make the Perl menu really only perl specific). (SZABGAB)
    - Allow the execution of PASM files using parrot if PARROT_PATH
      is defined. (SZABGAB)
    - Load Parrot::Embed if it is available. (SZABGAB)
    - Add Padre::Plugin::Parrot to show how to use pir for plugin writing. (SZABGAB)
    - Allow execution of Perl 6 code using Rakudo. (SZABGAB)
    - Add copyright/license to all the .pm files as per Debian request. (SZABGAB)
    - Ctrl-T is the default new file hot-key just as in Firefox. (ADAMK)
    - Dialog cleanups. (SMUELLER, ADAMK, SZABGAB)
    - Replace the toolbar icons with icons from the Tango project. (SZABGAB)

0.14 2008.10.27
    - Skip the Test::Compile test if the module is not installed. (SZABGAB)
    - Make the add/remove Perl menu work without warnings. (ADAMK + SZABGAB)
    - Make brace matching (Ctrl-1) jump to the matching brace. (SZABGAB)
    - Allow preference to use tabs (or spaces) when pressing TAB. (SZABGAB)
    - Add automatic brace highlighting during. (SZABGAB)

0.13 2008.10.26
    - fix warning when closing Padre with no files open (BRICAS)
    - close lone unused document when opening a recent file (now works the same
      as file->open) (BRICAS)
    - SplitWindow widgets are now used properly (ADAMK)
    - Show Output nows correctly hides away the output window when non-visible (ADAMK)
    - Refactored out output window to Padre::Wx::Output (ADAMK)
    - General refactoring pass over Padre::Wx (ADAMK)
    - Padre::Wx forces all the Wx::wxCONSTANT values to be populated,
      so that we don't need all the use Wx qw{ wxCONSTANT } imports (ADAMK)
    - Make it clear in the main window title if running from SVN checkout (ADAMK)
    - Add Padre::PluginBuilder for Padre plugins with extra build targets (SMUELLER)
    - Create dialog abstraction in Padre::Wx::Dialog. (SZABGAB)
    - Lots of refreshing related fixes. (SZABGAB)
    - Create Padre::Documents to return the current or any other document object. (SZABGAB)
    - Stop importing Wx directly in the Padre::Wx:: modules. (SZABGAB)
    - Compile all modules if Test::Compile is available during tests. (SZABGAB)
    - Save button on toolbar is working now when the current document needs saving. (SZABGAB)
    - Use binmode :raw in order to help Windows when opening and writing files
      fixing the bug that we used to change the newline types whem editing on Windows. (SZABGAB)
    - Run Script did not work bug fixed #76 (SZABGAB)
    - chdir to directory to be executed with Run Script #69 (SZABGAB)

0.12 2008.10.23
    - All changes below this point by SZABGAB unless noted.
    - Stupid bugs left in 0.11 reported by Brian Cassidy.

0.11 2008.10.23
    - Updated ORLite dependency to 0.14 for create => 1 support (ADAMK)
    - Rewrote Padre::DB to auto-configure directly from Padre::Config (ADAMK)
    - All Padre.pm DBI code converted to Padre::DB calls (ADAMK)
    - Removed minor use of Class::Accessor to reduce memory overhead,
      namespace pollution and dependency count (ADAMK)
    - Removed some superfluous code from the PIR/PASM/Perl6 documents (ADAMK)
    - Cleaned up (and shrunk the code for) the bootstrap sequence (ADAMK)
    - Moved the "recent files" internal state into the database (ADAMK)
    - Removed index pointers unrelated to the IDE from Padre.pm (ADAMK)
    - Transaction-wrap exiting to make it much much faster (ADAMK)
    - Adding shortcut methods for popup messages/errors (ADAMK)
    - Optimised away the non-Wx non-class Padre::Wx::Execute (ADAMK)
    - Created Padre::Wx::History::TextDialog so we can have a dialog
      box that defaults to whatever the last answer was. (ADAMK)
    - Some clean up in the FindDialog window with abstraction.
    - Add support to Module::Starter and make it to be a prereq.
    - Add all the perl functions to the Calltip keyword list and move
      it to a yaml file.
    - Fix several bugs that were probably introduced after 0.10.
    - Turn the color definition of the syntax highlighting into a hash
      for easier maintenance.
    - Lots of code refactoring.

0.10 2008.09.22
    - Improve the search tool (include backward search).
    - Allow keeping the search window open (or close it and use F3).
    - Shift-F3 to jump backwards.
    - Add Search and Replace and global search and replace.
    - Setup mapping of file extensions to mime-types and to color coding.
    - Clean up the MainWindow module, move code to Document and Document::Perl.
    - Implement an experimental PASM, PIR and Perl 6 highlighting.
    - Allow experimental code to allow the user to execute code within Padre.
    - Report if file could not be saved and keep it in unsaved state (bug #74).
    - Separate the Padre::Install module from Build.PL.
    - Set default mime-type of new files to be perl.
    - Change mime-type when saving file to the appropriate new mime-type.

0.09 2008.09.17
    - Move various relevant menu items into a "Window" menu (ADAMK)
    - Rename "Enable CallTip" to "Show Call Tips" for consistency (ADAMK)
    - Adding more menu seperators to improve the visual look (ADAMK)
    - Always show status bar on Win32, as removing it breaks (ADAMK)
    - Added experimental Padre::Document::Perl (ADAMK)
    - Added experimental PPI intergration (ADAMK)
    - Experimental menu refresh closer to being usable (ADAMK)
    - Split out Wx-related utility functions into Padre::Wx (ADAMK)
    - Adding common platform-detection logic to Padre::Util (ADAMK)
    - If we start with a new file and then open another one,
      implicitly close the unused new file (ADAMK)
    - Some dialog cleanups.
    - Make sure we can build stand alon executable for Linux.
    - Remove Ctrl-Shift-Z from redo as Ctrl-Y already works.

0.08 2008.09.11
    - Add Ctrl-Shift-O to open a file based on the selection in the current window.
    - Enable ack integration even though it is not nice yet but it is working.
    - Use real Wx:AboutDialogInfo for the about box.
    - Hide method names (in the method window) when they don't start on the first column.
    - Add menu option to close all buffers.
    - Escape $ signs by default so they will not interpolate during search.
    - Open file now opens in the directory where the current file is.
    - Add Bookmarks.
    - Add toolbar with several icons. Tested on Windows as well.
    - Add icon for the application.
    - Enable/disable regex in search.
    - Add menu option to convert line endings.
    - Replace relative path with full path on the command line.
    - Implement basic CallTips and add menu option to enable/disable them.

0.07 2008.09.04
    - Allow the user to change the width ot TABs as they are displayed.
    - Separate the code to show the preferences window to the Padre::Wx::Preferences module
    - Separate code to Padre::Wx::Menu, Padre::Wx::Execute, Padre::Wx::Help
    - Allow spliting windows to see two parts of the same document
    - Add Zoom-in/Zoom-out/Zoom-reset menu options to change the zoom on all documents
    - Allow the use of PAR files as plugins (SMUELLER)
    - Stop jumping on selection movement in the list of methods frame.
    - Remove Padre::Demo and distribute it separately as Wx::Perl::Dialog. Make Padre depend on it.
    - Update the status when the mouse is moved
    - Update status works on Windows now.
    - Require threaded perl as there is experimental code in Padre to use ack.
    - Depend on App::Ack.
    - Depend on PAR.
    - Clean up the par generation.
    - Lots of code cleanup.

0.06 2008.08.28
    - Add some "new file" templates
    - Temporarily remove the toolbar
    - Change behavior of Padre::Demo, add wxer command line interface
    - Remove Demo::App
    - Padre::Demo add dir_selector() and password()
    - Update list of methods on save as well #54 (vincent)
    - Change the list of subs on the right hand side to be sorted
    - Set Alt-S to jump to the subs list
    - Deal with newlines in files
    - Lots of refactoring (ADAMK)
    - Remember that application was maximized (ADAMK)
    - Better choice of default size (ADAMK)
    - Adding a separate compilation test script (ADAMK)
    - Adding a ORLite interface to the database Padre::DB (ADAMK)
    - Include authors tests for Perl critic and POD in xt/ directory
    - Make commenting out and uncommenting out atomic in the undo buffer
    - Replace string search by regex search, change the GUI
    - Add case insensitive search
    - Limit the max number of recent files to 20

0.05 2008.08.17
    - First stab at autocompletition using Ctrl-P. (SZABGAB)
    - Allow opening files without extensions (on non-ms-windows systems). (SZABGAB)
    - Cleaning up to comply with perlcritic default settings. (ADAMK)
    - Adding basic "project" support. (ADAMK)
    - Adding Module::Inspector as prereq. (ADAMK)
    - Replace YAML with YAML::Tiny (ADAMK)
    - Moved bin/padre to script/padre. (ADAMK)
    - Moving all globals into a unified object tree. (ADAMK)
    - Created standalone Padre::Config (ADAMK)
    - Show the filetpe in the status bar. (SZABGAB)
    - remove Devel::PerlySense as prereq for now. (SZABGAB)
    - List functions of the current file on the right panel. (SZABGAB)
    - Syntax highlighting of more file types (PATSPAM)

0.04 2008.08.08
    - add Devel::PerlySense as prereq
    - stop checking for wx version for now
    - change the create_makefile_pl to passthrough as the traditional did not do the extra work done by Build.PL
    - Mark the buffer that is unsaved with a star.
    - stop saving the content of the loaded file and use GetModify
      to find out if the file has been modifyed since last save
    - replace the search_term by search_terms in the config file
    - allow remembering of search terms
    - replace the text dialog by a full dialog box and a Wx::ComboBox
    - Setup http://padre.perlide.org/ using trac
    - Move the repository to http://svn.perlide.org/padre/

0.03_02 2008.08.03
    - add experimental code for plugins
    - add experimental version of Padre::Plugin::PAR
    - fix the shortcuts of some of the menues in windows, thanks to Octavian Rasnita
    - replace the AppendSubMenu calls by Append calls to support older version of wxWidgets

0.03_01 2008.07.31
    - Experimental code in Build.PL to avoid test failures when wxWidgets is too old.
    - Added ToolBar
    - Experimental code to install non-perl files and then use find them using File::ShareDir

0.03 2008.07.28
    - Fix many issues reported by Octavian Rasnita
    - Rename some internal modules to get full indexing

0.02 2008.07.26
    - First public release under the name Padre
    - Slow improvements
    - Nothing special or ground breaking to mention

0.01 2008.07.20
    - First version
